// D5D0dlg.cpp : implementation file
//

#include "stdafx.h"
#include "ch341par.h"
#include "D5D0dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CD5D0dlg dialog


CD5D0dlg::CD5D0dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD5D0dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD5D0dlg)
	//}}AFX_DATA_INIT
}


void CD5D0dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD5D0dlg)
	DDX_Control(pDX, IDC_CHECK_SLCTIN2, m_ctrlSLCTIN2);
	DDX_Control(pDX, IDC_CHECK_SLCTIN, m_ctrlSLCTIN);
	DDX_Control(pDX, IDC_CHECK_SLCT2, m_ctrlSLCT2);
	DDX_Control(pDX, IDC_CHECK_SLCT, m_ctrlSLCT);
	DDX_Control(pDX, IDC_CHECK_PEMP2, m_ctrlPEMP2);
	DDX_Control(pDX, IDC_CHECK_PEMP, m_ctrlPEMP);
	DDX_Control(pDX, IDC_CHECK_INT2, m_ctrlINT2);
	DDX_Control(pDX, IDC_CHECK_INT, m_ctrlINT);
	DDX_Control(pDX, IDC_CHECK_ERP2, m_ctrlERP2);
	DDX_Control(pDX, IDC_CHECK_ERP, m_ctrlERP);
	DDX_Control(pDX, IDC_CHECK_D7_IN, m_ctrlD7IN);
	DDX_Control(pDX, IDC_CHECK_D7, m_ctrlD7);
	DDX_Control(pDX, IDC_CHECK_D6_IN, m_ctrlD6IN);
	DDX_Control(pDX, IDC_CHECK_D6, m_ctrlD6);
	DDX_Control(pDX, IDC_CHECK_BUSY2, m_ctrlBusy2);
	DDX_Control(pDX, IDC_CHECK_BUSY, m_ctrlBusy);
	DDX_Control(pDX, IDC_CHECK_AUTOFD2, m_ctrlAuto2);
	DDX_Control(pDX, IDC_CHECK_AUTOFD, m_ctrlAuto);
	DDX_Control(pDX, IDC_CHECK_D5_IN, m_ctrlD5IN);
	DDX_Control(pDX, IDC_CHECK_D5, m_ctrlD5);
	DDX_Control(pDX, IDC_CHECK_D4_IN, m_ctrlD4IN);
	DDX_Control(pDX, IDC_CHECK_D4, m_ctrlD4);
	DDX_Control(pDX, IDC_CHECK_D3_IN, m_ctrlD3IN);
	DDX_Control(pDX, IDC_CHECK_D3, m_ctrlD3);
	DDX_Control(pDX, IDC_CHECK_D2_IN, m_ctrlD2IN);
	DDX_Control(pDX, IDC_CHECK_D2, m_ctrlD2);
	DDX_Control(pDX, IDC_CHECK_D1_IN, m_ctrlD1IN);
	DDX_Control(pDX, IDC_CHECK_D1, m_ctrlD1);
	DDX_Control(pDX, IDC_CHECK_D0_IN, m_ctrlD0IN);
	DDX_Control(pDX, IDC_CHECK_D0, m_ctrlD0);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CD5D0dlg, CDialog)
	//{{AFX_MSG_MAP(CD5D0dlg)
	ON_BN_CLICKED(IDC_CHECK_D0, OnCheckD0)
	ON_BN_CLICKED(IDC_CHECK_D1, OnCheckD1)
	ON_BN_CLICKED(IDC_CHECK_D2, OnCheckD2)
	ON_BN_CLICKED(IDC_CHECK_D3, OnCheckD3)
	ON_BN_CLICKED(IDC_CHECK_D4, OnCheckD4)
	ON_BN_CLICKED(IDC_CHECK_D5, OnCheckD5)
	ON_BN_CLICKED(IDC_CHECK_D6, OnCheckD6)
	ON_BN_CLICKED(IDC_CHECK_D7, OnCheckD7)
	ON_BN_CLICKED(IDC_CHECK_ERP2, OnCheckErp2)
	ON_BN_CLICKED(IDC_CHECK_PEMP2, OnCheckPemp2)
	ON_BN_CLICKED(IDC_CHECK_INT2, OnCheckInt2)
	ON_BN_CLICKED(IDC_CHECK_SLCT2, OnCheckSlct2)
	ON_BN_CLICKED(IDC_CHECK_BUSY2, OnCheckBusy2)
	ON_BN_CLICKED(IDC_CHECK_AUTOFD2, OnCheckAutofd2)
	ON_BN_CLICKED(IDC_BUTTON_REFRESH, OnButtonRefresh)
	ON_BN_CLICKED(IDC_CHECK_SLCTIN2, OnCheckSlctin2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD5D0dlg message handlers

void CD5D0dlg::OnButtonRefresh() 
{
	// TODO: Add your control notification handler code here
	ULONG mBuf[1];
	memset(mBuf, 0, sizeof(mBuf));
	UpdateData(TRUE);
	if(CPublic::m_open)
	{
		//////////////////////////////////////////////////////////////////////////
		//===״̬
		if (!CH341SetOutput(CPublic::mIndex, 0x1F, 0, 0))
		{
			MessageBox("ʧܣ ","CH341",MB_OK|MB_ICONSTOP);				
			return;
		}

		if (!CH341GetInput(CPublic::mIndex, &mBuf[0]))
		{
			MessageBox("״̬ʧܣ ","CH341",MB_OK|MB_ICONSTOP);				
			return;
		}
	
		//ť״̬ʾ
        if ((mBuf[0]&1))
			m_ctrlD0IN.SetCheck(1);
		else
			m_ctrlD0IN.SetCheck(0);
		if ((mBuf[0]&2))
			m_ctrlD1IN.SetCheck(1);
		else
			m_ctrlD1IN.SetCheck(0);
		if ((mBuf[0]&4))
			m_ctrlD2IN.SetCheck(1);
		else
			m_ctrlD2IN.SetCheck(0);
		if ((mBuf[0]&8))
			m_ctrlD3IN.SetCheck(1);
		else
			m_ctrlD3IN.SetCheck(0);
		if ((mBuf[0]&16))
			m_ctrlD4IN.SetCheck(1);
		else
			m_ctrlD4IN.SetCheck(0);
		if ((mBuf[0]&32))
			m_ctrlD5IN.SetCheck(1);
		else
			m_ctrlD5IN.SetCheck(0);
		if ((mBuf[0]&64))
			m_ctrlD6IN.SetCheck(1);
		else
			m_ctrlD6IN.SetCheck(0);

		if ((mBuf[0]&128))
			m_ctrlD7IN.SetCheck(1);
		else
			m_ctrlD7IN.SetCheck(0);

		if ((mBuf[0]&256))
			m_ctrlERP.SetCheck(1);
		else
			m_ctrlERP.SetCheck(0);

		if ((mBuf[0]&512))
			m_ctrlPEMP.SetCheck(1);
		else
			m_ctrlPEMP.SetCheck(0);

		if ((mBuf[0]&1024))
			m_ctrlINT.SetCheck(1);
		else
			m_ctrlINT.SetCheck(0);

		if ((mBuf[0]&2048))
			m_ctrlSLCT.SetCheck(1);
		else
			m_ctrlSLCT.SetCheck(0);

		if ((mBuf[0]&8192))
			m_ctrlBusy.SetCheck(1);
		else
			m_ctrlBusy.SetCheck(0);

		if ((mBuf[0]&16384))
			m_ctrlAuto.SetCheck(1);
		else
			m_ctrlAuto.SetCheck(0);

		if ((mBuf[0]&32768))
			m_ctrlSLCTIN.SetCheck(1);
		else
			m_ctrlSLCTIN.SetCheck(0);
	
		UpdateData(false);		
	}
	else
	{
		MessageBox("豸δ򿪣","CH341",MB_OK|MB_ICONSTOP);
	}

}

bool CD5D0dlg::DoWriteIO()
{
	ULONG mBuf[1];
	memset(mBuf, 0, sizeof(mBuf));
	UpdateData(true);
	mBuf[0] = (m_ctrlD5.GetCheck()<<5) | (m_ctrlD4.GetCheck()<<4) | (m_ctrlD3.GetCheck()<<3) | (m_ctrlD2.GetCheck()<<2) | \
		(m_ctrlD1.GetCheck()<<1) | m_ctrlD0.GetCheck() | (m_ctrlD6.GetCheck()<<6) | (m_ctrlD7.GetCheck()<<7) | (m_ctrlERP2.GetCheck()<<8) \
		| (m_ctrlPEMP2.GetCheck()<<9) | (m_ctrlINT2.GetCheck()<<10) | (m_ctrlSLCT2.GetCheck()<<11) | (m_ctrlBusy2.GetCheck()<<13) | (m_ctrlAuto2.GetCheck()<<14) | (m_ctrlSLCTIN2.GetCheck()<<15);
// 	CString tmpstr;
// 	tmpstr.Format("%02X", mBuf[0]);
// 	AfxMessageBox(tmpstr);

	if(CPublic::m_open)
	{
		try
		{
			if(!CH341SetOutput( CPublic::mIndex, 0x1F, 0xFFFF, mBuf[0] ) )
			{
				//					CH341SetTimeout(CPublic::mIndex, 0xFFFFFFFF, 0xFFFFFFFF);
				MessageBox("״̬ʧܣ","CH341",MB_OK|MB_ICONSTOP);
				return(false);
			}
		
		}
		catch( CException * )
		{
			TRACE("Error: %d",GetLastError());
			return(false);
		}
	}
	else
	{
		MessageBox("豸δ򿪣","CH341",MB_OK|MB_ICONSTOP);
		return(false);
	}
    return(true);
}

void CD5D0dlg::OnCheckD0() 
{
	// TODO: Add your control notification handler code here
	
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckD1() 
{
	// TODO: Add your control notification handler code here

	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckD2() 
{
	// TODO: Add your control notification handler code here

	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckD3() 
{
	// TODO: Add your control notification handler code here

	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckD4() 
{
	// TODO: Add your control notification handler code here

	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckD5() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckD6() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckD7() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckErp2() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckPemp2() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckInt2() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckSlct2() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckBusy2() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckAutofd2() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}

void CD5D0dlg::OnCheckSlctin2() 
{
	// TODO: Add your control notification handler code here
	if(CPublic::m_open)
	{
		if(DoWriteIO()==false)  //LED״̬
			MessageBox("ʧܣ","CH341",MB_OK|MB_ICONSTOP);
	}
}
